# Uses of Class
com.fasterxml.jackson.core.io.ContentReference

Packages that use ContentReference
Package
Description
com.fasterxml.jackson.core
Main public API classes of the core streaming JSON processor: most importantly `JsonFactory` used for constructing JSON parser (`JsonParser`) and generator (`JsonGenerator`) instances.
com.fasterxml.jackson.core.base
Base classes used by concrete Parser and Generator implementations; contain functionality that is not specific to JSON or input abstraction (byte vs char).
com.fasterxml.jackson.core.io
com.fasterxml.jackson.core.json
JSON-specific parser and generator implementation classes that Jackson defines and uses.

## Uses of ContentReference in com.fasterxml.jackson.core

Fields in com.fasterxml.jackson.core declared as ContentReference
Modifier and Type
Field
Description
`protected final ContentReference`
JsonLocation.`_contentReference`
Reference to input source; never null (but may be that of `unknown()`).
Methods in com.fasterxml.jackson.core that return ContentReference
Modifier and Type
Method
Description
`protected ContentReference`
JsonFactory.`_createContentReference(Object contentAccessor)`
Overridable factory method for constructing `ContentReference` to pass to parser or generator being created; used in cases where no offset or length is applicable (either irrelevant, or full contents assumed).
`protected ContentReference`
JsonFactory.`_createContentReference(Object contentAccessor, int offset, int length)`
Overridable factory method for constructing `ContentReference` to pass to parser or generator being created; used in cases where content is available in a static buffer with relevant offset and length (mostly when reading from `byte[]`, `char[]` or `String`).
`protected static ContentReference`
JsonLocation.`_wrap(Object srcRef)`
`ContentReference`
JsonLocation.`contentReference()`
Accessor for information about the original input source content is being read from.
Methods in com.fasterxml.jackson.core with parameters of type ContentReference
Modifier and Type
Method
Description
`protected IOContext`
JsonFactory.`_createContext(ContentReference contentRef, boolean resourceManaged)`
Overridable factory method that actually instantiates desired context object.
`JsonLocation`
JsonStreamContext.`startLocation(ContentReference srcRef)`
Optional method that may be used to access starting location of this context: for example, in case of JSON `Object` context, offset at which `[` token was read or written.
Constructors in com.fasterxml.jackson.core with parameters of type ContentReference
Modifier
Constructor
Description
``
`JsonLocation(ContentReference contentRef, long totalChars, int lineNr, int colNr)`
``
`JsonLocation(ContentReference contentRef, long totalBytes, long totalChars, int lineNr, int columnNr)`

## Uses of ContentReference in com.fasterxml.jackson.core.base

Methods in com.fasterxml.jackson.core.base that return ContentReference
Modifier and Type
Method
Description
`protected ContentReference`
ParserBase.`_contentReference()`
Helper method used to encapsulate logic of including (or not) of "content reference" when constructing `JsonLocation` instances.
`protected ContentReference`
ParserBase.`_contentReferenceRedacted()`
Helper method used to encapsulate logic of providing "content reference" when constructing `JsonLocation` instances and source information is NOT to be included (`StreamReadFeature.INCLUDE_SOURCE_IN_LOCATION` disabled).

## Uses of ContentReference in com.fasterxml.jackson.core.io

Fields in com.fasterxml.jackson.core.io declared as ContentReference
Modifier and Type
Field
Description
`protected final ContentReference`
IOContext.`_contentReference`
Reference to the source object, which can be used for displaying location information
`protected static final ContentReference`
ContentReference.`REDACTED_CONTENT`
As content will be redacted by default in Jackson 2.16 and later, we'll use a new marker reference for slightly different description from "unknown", to indicate explicit removal of source/content reference (as opposed to it missing from not being available or so)
`protected static final ContentReference`
ContentReference.`UNKNOWN_CONTENT`
Constant that may be used when source/target content is not known (or not exposed).
Methods in com.fasterxml.jackson.core.io that return ContentReference
Modifier and Type
Method
Description
`static ContentReference`
ContentReference.`construct(boolean isContentTextual, Object rawContent)`
Deprecated.
Since 2.16.
`static ContentReference`
ContentReference.`construct(boolean isContentTextual, Object rawContent, int offset, int length)`
Deprecated.
Since 2.16.
`static ContentReference`
ContentReference.`construct(boolean isContentTextual, Object rawContent, int offset, int length, ErrorReportConfiguration errorReportConfiguration)`
`static ContentReference`
ContentReference.`construct(boolean isContentTextual, Object rawContent, ErrorReportConfiguration errorReportConfiguration)`
`ContentReference`
IOContext.`contentReference()`
Accessor for getting (some) information about input source, mostly usable for error reporting purposes.
`static ContentReference`
ContentReference.`rawReference(boolean isContentTextual, Object rawContent)`
Factory method for legacy code to use for constructing instances to content about which only minimal amount of information is available.
`static ContentReference`
ContentReference.`rawReference(Object rawContent)`
`static ContentReference`
ContentReference.`redacted()`
Accessor for getting a placeholder when actual content is not to be exposed: different from `unknown()` where content is not available to be referenced.
`static ContentReference`
ContentReference.`unknown()`
Accessor for getting a placeholder for cases where actual content is not known (or is not something that system wants to expose).
Constructors in com.fasterxml.jackson.core.io with parameters of type ContentReference
Modifier
Constructor
Description
``
`IOContext(StreamReadConstraints src, StreamWriteConstraints swc, ErrorReportConfiguration erc, BufferRecycler br, ContentReference contentRef, boolean managedResource)`
Main constructor to use.
``
`IOContext(StreamReadConstraints src, BufferRecycler br, ContentReference contentRef, boolean managedResource)`
Deprecated.
Since 2.16.
``
`IOContext(BufferRecycler br, ContentReference contentRef, boolean managedResource)`
Deprecated.
Since 2.15.

## Uses of ContentReference in com.fasterxml.jackson.core.json

Methods in com.fasterxml.jackson.core.json with parameters of type ContentReference
Modifier and Type
Method
Description
`JsonLocation`
JsonReadContext.`startLocation(ContentReference srcRef)`